--- trunk/chan_dahdi.c	2009/07/17 13:25:01	46
+++ trunk/chan_dahdi.c	2009/07/17 14:00:07	47
@@ -3572,9 +3570,16 @@
 	struct dahdi_pvt *p = ast->tech_pvt;
 	int res = 0;
 	int index;
+	
+	ast_mutex_lock(&p->lock);
+
+	if (ast->_state == AST_STATE_UP) {
+		ast_mutex_unlock(&p->lock);
+		return res;
+	}
+
 	int oldstate = ast->_state;
 	ast_setstate(ast, AST_STATE_UP);
-	ast_mutex_lock(&p->lock);
 	index = dahdi_get_index(ast, p, 0);
 	if (index < 0)
 		index = SUB_REAL;
